/*  $RCSfile: memmod.h,v $ */
/*  $Author: nakane $ */
/*  $Date: 1999/12/20 02:56:44 $ */
/*  $Revision: 1.1.1.1 $ */
/*  $State: Exp $ */
declare memmod {
  input  i0,  i1,  i2,  i3,  i4,  i5,  i6,  i7;
  input  i8,  i9, i10, i11, i12, i13, i14, i15;
  input i16, i17, i18, i19, i20, i21, i22, i23;
  input i24, i25, i26, i27, i28, i29, i30, i31;

  output  o0,  o1,  o2,  o3,  o4,  o5,  o6,  o7;
  output  o8,  o9, o10, o11, o12, o13, o14, o15;
  output o16, o17, o18, o19, o20, o21, o22, o23;
  output o24, o25, o26, o27, o28, o29, o30, o31;

  instrin  do0,  do1,  do2,  do3,  do4,  do5,  do6,  do7;
  instrin  do8,  do9, do10, do11, do12, do13, do14, do15;
  instrin do16, do17, do18, do19, do20, do21, do22, do23;
  instrin do24, do25, do26, do27, do28, do29, do30, do31;
  instrin complete;

  input  rn_we0,  rn_we1,  rn_we2,  rn_we3,  rn_we4,  rn_we5,  rn_we6,  rn_we7;
  input  rn_we8,  rn_we9, rn_we10, rn_we11, rn_we12, rn_we13, rn_we14, rn_we15;
  input rn_we16, rn_we17, rn_we18, rn_we19, rn_we20, rn_we21, rn_we22, rn_we23;
  input rn_we24, rn_we25, rn_we26, rn_we27, rn_we28, rn_we29, rn_we30, rn_we31;

  input  adr0<16>,  adr1<16>,  adr2<16>,  adr3<16>;
  input  adr4<16>,  adr5<16>,  adr6<16>,  adr7<16>;
  input  adr8<16>,  adr9<16>, adr10<16>, adr11<16>;
  input adr12<16>, adr13<16>, adr14<16>, adr15<16>;
  input adr16<16>, adr17<16>, adr18<16>, adr19<16>;
  input adr20<16>, adr21<16>, adr22<16>, adr23<16>;
  input adr24<16>, adr25<16>, adr26<16>, adr27<16>;
  input adr28<16>, adr29<16>, adr30<16>, adr31<16>;
  
  instr_arg  do0(  rn_we0,  adr0,  i0); instr_arg  do1(  rn_we1,  adr1,	i1);
  instr_arg  do2(  rn_we2,  adr2,  i2); instr_arg  do3(  rn_we3,  adr3,  i3);
  instr_arg  do4(  rn_we4,  adr4,  i4); instr_arg  do5(  rn_we5,  adr5,  i5);
  instr_arg  do6(  rn_we6,  adr6,  i6); instr_arg  do7(  rn_we7,  adr7,  i7);
  instr_arg  do8(  rn_we8,  adr8,  i8); instr_arg  do9(  rn_we9,  adr9,  i9);
  instr_arg do10( rn_we10, adr10, i10); instr_arg do11( rn_we11, adr11, i11);
  instr_arg do12( rn_we12, adr12, i12); instr_arg do13( rn_we13, adr13, i13);
  instr_arg do14( rn_we14, adr14, i14); instr_arg do15( rn_we15, adr15, i15);
  instr_arg do16( rn_we16, adr16, i16); instr_arg do17( rn_we17, adr17, i17); 
  instr_arg do18( rn_we18, adr18, i18); instr_arg do19( rn_we19, adr19, i19);
  instr_arg do20( rn_we20, adr20, i20); instr_arg do21( rn_we21, adr21, i21); 
  instr_arg do22( rn_we22, adr22, i22); instr_arg do23( rn_we23, adr23, i23); 
  instr_arg do24( rn_we24, adr24, i24); instr_arg do25( rn_we25, adr25, i25); 
  instr_arg do26( rn_we26, adr26, i26); instr_arg do27( rn_we27, adr27, i27); 
  instr_arg do28( rn_we28, adr28, i28); instr_arg do29( rn_we29, adr29, i29);
  instr_arg do30( rn_we30, adr30, i30); instr_arg do31( rn_we31, adr31, i31); 

}
